﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class init4 : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_SolutionAssessment_SolutionVersions_SolutionVersionId",
                table: "SolutionAssessment");

            migrationBuilder.DropIndex(
                name: "IX_SolutionAssessment_SolutionVersionId",
                table: "SolutionAssessment");

            migrationBuilder.AddColumn<bool>(
                name: "HadAutomaticAssessmentErrors",
                table: "ExerciseReleases",
                nullable: false,
                defaultValue: false);

            migrationBuilder.AddColumn<bool>(
                name: "HasAutomaticAssessmentFinished",
                table: "ExerciseReleases",
                nullable: false,
                defaultValue: false);

            migrationBuilder.AddColumn<bool>(
                name: "HasAutomaticAssessmentStarted",
                table: "ExerciseReleases",
                nullable: false,
                defaultValue: false);

            migrationBuilder.AlterColumn<int>(
                name: "SolutionVersionId",
                table: "SolutionAssessment",
                nullable: true);

            migrationBuilder.CreateIndex(
                name: "IX_SolutionAssessment_SolutionVersionId",
                table: "SolutionAssessment",
                column: "SolutionVersionId",
                unique: true);

            migrationBuilder.AddForeignKey(
                name: "FK_SolutionAssessment_SolutionVersions_SolutionVersionId",
                table: "SolutionAssessment",
                column: "SolutionVersionId",
                principalTable: "SolutionVersions",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_SolutionAssessment_SolutionVersions_SolutionVersionId",
                table: "SolutionAssessment");

            migrationBuilder.DropIndex(
                name: "IX_SolutionAssessment_SolutionVersionId",
                table: "SolutionAssessment");

            migrationBuilder.DropColumn(
                name: "HadAutomaticAssessmentErrors",
                table: "ExerciseReleases");

            migrationBuilder.DropColumn(
                name: "HasAutomaticAssessmentFinished",
                table: "ExerciseReleases");

            migrationBuilder.DropColumn(
                name: "HasAutomaticAssessmentStarted",
                table: "ExerciseReleases");

            migrationBuilder.AlterColumn<int>(
                name: "SolutionVersionId",
                table: "SolutionAssessment",
                nullable: false);

            migrationBuilder.CreateIndex(
                name: "IX_SolutionAssessment_SolutionVersionId",
                table: "SolutionAssessment",
                column: "SolutionVersionId");

            migrationBuilder.AddForeignKey(
                name: "FK_SolutionAssessment_SolutionVersions_SolutionVersionId",
                table: "SolutionAssessment",
                column: "SolutionVersionId",
                principalTable: "SolutionVersions",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
