﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class removeSolutionVersion2 : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateIndex(
                name: "IX_SolutionFiles_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "SolutionFiles",
                columns: new[] { "SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId" });

            migrationBuilder.CreateIndex(
                name: "IX_Solutions_MainFileId",
                table: "Solutions",
                column: "MainFileId",
                unique: true);

            migrationBuilder.AddForeignKey(
                name: "FK_Solutions_SolutionFiles_MainFileId",
                table: "Solutions",
                column: "MainFileId",
                principalTable: "SolutionFiles",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);

            migrationBuilder.AddForeignKey(
                name: "FK_SolutionFiles_Solutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "SolutionFiles",
                columns: new[] { "SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId" },
                principalTable: "Solutions",
                principalColumns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                onDelete: ReferentialAction.Cascade);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Solutions_SolutionFiles_MainFileId",
                table: "Solutions");

            migrationBuilder.DropForeignKey(
                name: "FK_SolutionFiles_Solutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "SolutionFiles");

            migrationBuilder.DropIndex(
                name: "IX_SolutionFiles_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "SolutionFiles");

            migrationBuilder.DropIndex(
                name: "IX_Solutions_MainFileId",
                table: "Solutions");
        }
    }
}
