﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class ExerciseTestAssetFiles : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "FileReferenceTestAssets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    Hash = table.Column<string>(maxLength: 500, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(maxLength: 500, nullable: true),
                    OriginalName = table.Column<string>(maxLength: 500, nullable: true),
                    RelativePath = table.Column<string>(maxLength: 5000, nullable: true),
                    SizeInBytes = table.Column<long>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_FileReferenceTestAssets", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "TestWithFileAsAssetReferences",
                columns: table => new
                {
                    TestId = table.Column<int>(nullable: false),
                    FileReferenceTestAssetId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestWithFileAsAssetReferences", x => new { x.TestId, x.FileReferenceTestAssetId });
                    table.ForeignKey(
                        name: "FK_TestWithFileAsAssetReferences_FileReferenceTestAssets_FileReferenceTestAssetId",
                        column: x => x.FileReferenceTestAssetId,
                        principalTable: "FileReferenceTestAssets",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TestWithFileAsAssetReferences_Tests_TestId",
                        column: x => x.TestId,
                        principalTable: "Tests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_TestWithFileAsAssetReferences_FileReferenceTestAssetId",
                table: "TestWithFileAsAssetReferences",
                column: "FileReferenceTestAssetId");

            migrationBuilder.CreateIndex(
                name: "IX_TestWithFileAsAssetReferences_TestId",
                table: "TestWithFileAsAssetReferences",
                column: "TestId");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "TestWithFileAsAssetReferences");

            migrationBuilder.DropTable(
                name: "FileReferenceTestAssets");
        }
    }
}
