﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class RemoveOldDbAssets : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_CustomProjectTestAssets_CustomProjectTests_CustomProjectTestId",
                table: "CustomProjectTestAssets");

            migrationBuilder.DropIndex(
                name: "IX_CustomProjectTestAssets_CustomProjectTestId",
                table: "CustomProjectTestAssets");

            migrationBuilder.DropColumn(
                name: "CustomProjectTestId",
                table: "CustomProjectTestAssets");

            migrationBuilder.DropTable(
                name: "Assets");

            migrationBuilder.DropTable(
                name: "CustomTestAssets");

            migrationBuilder.DropTable(
                name: "TestAssets");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "Assets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    AssetUrl = table.Column<string>(maxLength: 500, nullable: true),
                    Content = table.Column<byte[]>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomProjectDescriptionId = table.Column<int>(nullable: true),
                    DisplayName = table.Column<string>(maxLength: 500, nullable: true),
                    ExerciseDescriptionId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(maxLength: 500, nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Assets", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Assets_CustomProjectDescriptions_CustomProjectDescriptionId",
                        column: x => x.CustomProjectDescriptionId,
                        principalTable: "CustomProjectDescriptions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                    table.ForeignKey(
                        name: "FK_Assets_ExerciseDescriptions_ExerciseDescriptionId",
                        column: x => x.ExerciseDescriptionId,
                        principalTable: "ExerciseDescriptions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomTestAssets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    Content = table.Column<byte[]>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomTestId = table.Column<int>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 500, nullable: true),
                    Hash = table.Column<string>(maxLength: 500, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(maxLength: 500, nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomTestAssets", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomTestAssets_CustomTest_CustomTestId",
                        column: x => x.CustomTestId,
                        principalTable: "CustomTest",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "TestAssets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    Content = table.Column<byte[]>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 500, nullable: true),
                    Hash = table.Column<string>(maxLength: 500, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(maxLength: 500, nullable: true),
                    TestId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestAssets", x => x.Id);
                    table.ForeignKey(
                        name: "FK_TestAssets_Tests_TestId",
                        column: x => x.TestId,
                        principalTable: "Tests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.AddColumn<int>(
                name: "CustomProjectTestId",
                table: "CustomProjectTestAssets",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTestAssets_CustomProjectTestId",
                table: "CustomProjectTestAssets",
                column: "CustomProjectTestId");

            migrationBuilder.CreateIndex(
                name: "IX_Assets_CustomProjectDescriptionId",
                table: "Assets",
                column: "CustomProjectDescriptionId");

            migrationBuilder.CreateIndex(
                name: "IX_Assets_ExerciseDescriptionId",
                table: "Assets",
                column: "ExerciseDescriptionId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestAssets_CustomTestId",
                table: "CustomTestAssets",
                column: "CustomTestId");

            migrationBuilder.CreateIndex(
                name: "IX_TestAssets_TestId",
                table: "TestAssets",
                column: "TestId");

            migrationBuilder.AddForeignKey(
                name: "FK_CustomProjectTestAssets_CustomProjectTests_CustomProjectTestId",
                table: "CustomProjectTestAssets",
                column: "CustomProjectTestId",
                principalTable: "CustomProjectTests",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
